# HoneyPy Copyright (C) 2013-2016 foospidy
# https://github.com/foospidy/HoneyPy
# See LICENSE for details

from twisted.internet.protocol import DatagramProtocol
from twisted.python import log
import uuid

### START CUSTOM IMPORTS ###

############################

class pluginMain(DatagramProtocol):
	
	def datagramReceived(self, data, (host, port)):
		self.rx(host, port, data)
		
	 	### START CUSTOM CODE ####################################################################a
                Authorization ="" 
                Via=""
                From=""
                To=""
                CallID=""
                Contact=""
                sip=data.split("\r\n")
                for header in sip:
                        if "Via:" in header:
                                Via=header
                        elif "From:" in header:
                                From=header
                        elif "To:" in header:
                                To=header
                        elif "Call-ID:" in header:
                                CallID=header
                        elif "CSeq:" in header:
                                CSeq=header
                        elif "User-Agent:" in header:
                                UserAgent=header
                        elif "Contact:" in header:
                                Contact=header
                        elif "Expires:" in header:
                                Expires=header
                        elif "Allow:" in header:
                                Allow=header
                        elif "Content-Lenght:" in header:
                                Lenght=header
                        elif "Authorization:" in header:
                                Authorization=header

                Unauthorized="SIP/2.0 401 Unauthorized\r\n"
                Unauthorized+=Via+"\r\n"
                Unauthorized+=From+"\r\n"
                Unauthorized+=To+"\r\n"
                Unauthorized+=CallID+"\r\n"
                Unauthorized+="CSeq: 1 REGISTER\r\n"
                Unauthorized+='WWW-Authenticate: Digest realm="sipplugin.com", nonce="ea9c8e88df84f1cec4341ae6cbe5a359"\r\n'
                Unauthorized+="Server: OpenSER (1.2.1-notls (x86_64/linux))\r\n"
                Unauthorized+="Content-Length: 0\r\n\r\n"
   
                OK="SIP/2.0 200 OK\r\n"
                OK+=Via+"\r\n"
                OK+=From+"\r\n"
                OK+=To + "\r\n"
                OK+=CallID+"\r\n"
                if "INVITE" in sip[0]:
			OK+="CSeq: 2 INVITE\r\n"
		elif "BYE" in sip[0]:
			OK+="CSeq: 2 BYE\r\n"
                else:
                        OK+="CSeq: 2 REGISTER\r\n"
                OK+=Contact+"\r\n"
                OK+="Server: OpenSER (1.2.1-notls (x86_64/linux))\r\n"
                OK+="Content-Length: 0\r\n\r\n"


                if "REGISTER" in sip[0]:
			if Authorization != "":
			      self.tx(host, port, OK)
                        else:
			      self.tx(host, port, Unauthorized)
                if "INVITE" in sip[0]:
                        self.tx(host, port, OK)
                if "BYE" in sip[0]:
                        self.tx(host, port, OK)
                else:
			self.tx(host, port, Unauthorized)
	
		##########################################################################################

	### START CUSTOM FUNCTIONS ###################################################################

	##############################################################################################
	
	def tx(self, host, port, data):
		log.msg('%s UDP TX %s %s %s %s %s %s' % (self.session, self.host, self.port, self.name, host, port, data.encode("hex")))
		self.transport.write(data, (host, port))

	def rx(self, host, port, data):
		self.session = uuid.uuid1()
		log.msg('%s UDP RX %s %s %s %s %s %s' % (self.session, self.host, self.port, self.name, host, port, data.encode("hex")))

	def __init__(self, name=None, host=None, port=None):
		self.name    = name or 'HoneyPy'
		self.host    = host or '???'
		self.port    = port or '???'
		self.session = None
